# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

module Sqreen
  module Actions
    # documents the operations an actions index should implement
    class ActionsIndex
      # all actions matching, possibly already expired
      def actions_matching(_key)
        raise 'implement in subclasses'
      end

      def index(_params, _action)
        raise 'implement in subclasses'
      end
    end
  end
end
