# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/exception'

module Sqreen
  # Implements actions (behavior taken in response to agent signals)
  module Actions
    # Exception for when an unknown action type is gotten from the server
    class UnknownActionType < ::Sqreen::Exception
      attr_reader :action_type
      def initialize(action_type)
        super("no such action type: #{action_type}. Must be one of #{Base.known_types}")
        @action_type = action_type
      end
    end
  end
end
