# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/actions/actions_index'

module Sqreen
  module Actions
    class UsersIndex < ActionsIndex
      def actions_matching(identity_params)
        return [] unless @idx
        key = stringify_keys(identity_params)
        actions = @idx[key]
        actions || []
      end

      def index(params, action)
        @idx ||= {}
        users = params['users']
        raise ::Sqreen::Exception, 'nil "users" param for block_user action' if users.nil?
        raise ::Sqreen::Exception, '"users" param must be an array' unless users.is_a? Array

        users.each do |u|
          @idx[u] ||= []
          @idx[u] << action
        end
      end

      private

      def stringify_keys(hash)
        Hash[
          hash.map { |k, v| [k.to_s, v] }
        ]
      end
    end
  end
end
