# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'digest'

module Sqreen
  class AgentMessage
    def initialize(kind, message, id = nil)
      id ||= message + "\x00" + kind
      @hash_hex = Digest::SHA1.hexdigest(id)
      @kind = kind
      @message = message
    end

    def to_h
      {
        id: @hash_hex,
        kind: @kind,
        message: @message,
      }
    end
  end
end
