# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/rules/rule_cb'
require 'sqreen/metrics/base'

module Sqreen
  class AggregatedMetric
    def initialize(values = {})
      values.each do |k, v|
        public_send "#{k}=", v
      end
    end

    # @return [Sqreen::Rules::RuleCB]
    attr_accessor :rule # optional

    # @return [Sqreen::Metric::Base]
    attr_accessor :metric

    attr_accessor :start, :finish
    attr_accessor :data

    def name
      metric.name
    end
  end
end
