# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

module Sqreen
  module Dependency
    def self.const_exist?(name)
      resolve_const(name) && true
    rescue NameError, ArgumentError
      false
    end

    def self.resolve_const(name)
      raise ArgumentError if name.nil? || name.empty?

      name.to_s.split('::').inject(Object) { |a, e| a.const_get(e, false) }
    end
  end
end
