# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/dependency'

module Sqreen
  module Dependency
    module LibSqreen
      module_function

      def require_libsqreen
        raise LoadError, 'libsqreen forcefully disabled by configuration' unless Sqreen.config_get('libsqreen')
        require 'libsqreen'
        @libsqreen = true
      rescue LoadError => e
        Sqreen.log.warn("libsqreen gem not required: #{e.message}")
        @libsqreen = false
      end

      def required?
        require_libsqreen if @libsqreen.nil?
        Sqreen::Dependency.const_exist?('LibSqreen')
      end

      def stub?
        !::LibSqreen.respond_to?(:version)
      end
    end
  end
end
