# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/loggable'

module Sqreen
  module Ecosystem
    # The API that the transport/tracing modules are written against
    module ModuleApi
      TRACE_ID_HEADER = 'X-Sqreen-Trace-Identifier'.freeze
      TRACE_ID_ENV_KEY = 'HTTP_X_SQREEN_TRACE_IDENTIFIER'.freeze

      Loggable = Sqreen::Ecosystem::Loggable

      module ClassMethods
        attr_writer :module_name

        def module_name
          if instance_variable_defined?(:@module_name)
            @module_name
          else
            # to snake case
            @module_name = to_s.sub(/.*::/, '').gsub(/([a-z])([A-Z])/, '\1_\2').downcase
          end
        end
      end

      def self.included(mod)
        mod.extend(ClassMethods)
      end
    end
  end
end
