# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/module_api'

module Sqreen
  module Ecosystem
    module ModuleApi
      module Instrumentation
        def self.included(mod)
          mod.send :include, ModuleApi unless mod.ancestors.include?(ModuleApi)
        end

        private

        # Just forwards the call to the instrumentation service
        # @param [String] method
        # @param [Hash{Symbol=>Proc}] advice keys are one of: :before, :after,
        #                             :raised,
        def instrument(method, advice)
          DispatchTable.instrument.call(self.class.module_name, method, advice)
        end
      end
    end
  end
end
