# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/tracing/modules/determine_ip'
require 'sqreen/ecosystem/tracing/signals/tracing_client'
require 'sqreen/ecosystem/loggable'
require 'sqreen/ecosystem/module_api'
require 'sqreen/ecosystem/module_api/tracing'
require 'sqreen/ecosystem/module_api/tracing/client_data'

module Sqreen
  module Ecosystem
    module Tracing
      module Modules
        class Client
          include ModuleApi::Tracing
          include ModuleApi::TracingIdGeneration
          include ModuleApi::Loggable

          consumes    ModuleApi::Tracing::ClientData
          fixed_scope 'client'

          def receive(data)
            signal = Tracing::Signals::TracingClient.new
            signal.payload = Tracing::Signals::TracingClient::Payload.new(
              transport: data.transport,
              host: data.host || '',
              ip: data.ip,
              tracing_identifier: data.tracing_identifier || create_tracing_id
            )

            submit_signal signal
          end
        end
      end
    end
  end
end
