# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/tracing/modules/determine_ip'
require 'sqreen/ecosystem/tracing/signals/tracing_consumer'
require 'sqreen/ecosystem/module_api'
require 'sqreen/ecosystem/module_api/tracing/consumer_data'

module Sqreen
  module Ecosystem
    module Tracing
      module Modules
        class Consumer
          include ModuleApi::Tracing
          include ModuleApi::TracingIdGeneration
          include ModuleApi::Loggable

          consumes    ModuleApi::Tracing::ConsumerData
          fixed_scope 'consumer'

          # @param [ModuleApi::Tracing::ConsumerData] data
          def receive(data)
            signal = Tracing::Signals::TracingConsumer.new
            signal.payload = Tracing::Signals::TracingConsumer::Payload.new(
              message_type: data.message_type,
              host: data.host || '',
              ip: data.ip,
              topic: data.topic,
              tracing_identifier: data.tracing_identifier || create_tracing_id
            )

            submit_signal signal
          end
        end
      end
    end
  end
end
