# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/module_api'

module Sqreen
  module Ecosystem
    module Tracing
      module Modules
        module DetermineIp
          class << self
            include ModuleApi::Loggable

            def [](data)
              return data.ip if data.ip

              return nil unless data.host && !data.host.empty?

              begin
                IPSocket.getaddress data.host
              rescue SocketError => e
                logger.info { "Error resolving #{data.host}: #{e.message}" }
                nil
              end
            end
          end
        end
      end
    end
  end
end
