# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/ecosystem/tracing/signals/tracing_server'
require 'sqreen/ecosystem/module_api/tracing'
require 'sqreen/ecosystem/module_api/tracing/server_data'

module Sqreen
  module Ecosystem
    module Tracing
      module Modules
        class Server
          include ModuleApi::Tracing

          consumes    ModuleApi::Tracing::ServerData
          fixed_scope 'server'

          # @param [Sqreen::Ecosystem::ModuleApi::Tracing::ServerData] data
          def receive(data)
            signal = Tracing::Signals::TracingServer.new
            signal.payload = Tracing::Signals::TracingServer::Payload.new(
              transport: data.transport,
              client_ip: data.client_ip,
              tracing_identifier: data.tracing_identifier
            )

            submit_signal signal
          end
        end
      end
    end
  end
end
