# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/log/loggable'

module Sqreen
  class EcosystemIntegration
    class SignalConsumption
      include Sqreen::Log::Loggable

      # @param [Sqreen::Frameworks::GenericFramework] framework
      # @param [Sqreen::EcosystemIntegration::RequestLifecycleTracking]
      # @param [Sqreen::CappedQueue]
      def initialize(framework, req_lifecycle, queue)
        @framework = framework
        @req_lifecycle = req_lifecycle
        @queue = queue
      end

      def consume_signal(signal)
        # transitional
        unless Sqreen.features.fetch('use_signals', DEFAULT_USE_SIGNALS)
          logger.debug { "Discarding signal #{signal} (signals disabled)" }
          return
        end

        @queue.push signal
      end
    end
  end
end
