# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

# TODO: see sqreen/events

module Sqreen
  # Master interface for point in time events (e.g. Attack, RemoteException)
  class Event
    # @return [Hash]
    attr_reader :payload

    # @return [Time]
    attr_accessor :time # writer used only in tests

    def initialize(payload)
      @payload = payload
      @time = Time.now.utc
    end

    def to_s
      "<#{self.class.name}: #{payload.to_hash}>"
    end
  end
end
