# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

# TODO: sqreen/events

require 'sqreen/event'

module Sqreen
  # Attack
  # When creating a new attack, it gets automatically pushed to the event's
  # queue.
  # XXX: TURNS OUT THIS CLASS IS ACTUALLY NOT USED ANYMORE
  # Framework.observe is used instead with unstructured attack details
  class Attack < Event
    def self.record(payload)
      attack = Attack.new(payload)
      attack.enqueue
    end

    def infos
      payload['infos']
    end

    def rulespack_id
      return nil unless payload['rule']
      payload['rule']['rulespack_id']
    end

    def rule_name
      return nil unless payload['rule']
      payload['rule']['name']
    end

    def test?
      return nil unless payload['rule']
      payload['rule']['test'] ? true : false
    end

    def beta?
      return nil unless payload['rule']
      payload['rule']['beta'] ? true : false
    end

    def block?
      return nil unless payload['rule']
      payload['rule']['block'] ? true : false
    end

    def attack_type
      return nil unless payload['rule']
      payload['rule']['attack_type']
    end

    def time
      return nil unless payload['local']
      payload['local']['time']
    end

    def backtrace
      return nil unless payload['context']
      payload['context']['backtrace']
    end

    def datadog_trace_id
      payload['context']['datadog_trace_id']
    end

    def datadog_span_id
      payload['context']['datadog_span_id']
    end

    def enqueue
      Sqreen.queue.push(self)
    end
  end
end
