# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/log'

module Sqreen
  # TODO: do we really want this to be StandardError?
  # Base exeception class for sqreen
  class Exception < ::StandardError
    def initialize(msg = nil, *args)
      super(msg, *args)
      log_message msg if msg
    end

    def log_message(msg)
      Sqreen.log.error(msg)
    end
  end
end

require 'sqreen/token_not_found_exception'
require 'sqreen/token_invalid_exception'
require 'sqreen/attack_blocked'
require 'sqreen/not_implemented_yet'
require 'sqreen/invalid_signature_exception'
require 'sqreen/unauthorized'
require 'sqreen/waf_error'
