# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/cb'
require 'sqreen/shared_storage'

module Sqreen
  # Framework-aware callback
  class FrameworkCB < CB
    attr_accessor :framework

    def whitelisted?
      whitelisted = SharedStorage.get(:whitelisted)
      return whitelisted unless whitelisted.nil?
      framework && !framework.whitelisted_match.nil?
    end

    # Record a metric observation
    # @param category [String] Name of the metric observed
    # @param key [String] aggregation key
    # @param observation [Object] data observed
    # @param at [Time] time when observation was made
    def record_observation(category, key, observation, at = Time.now.utc)
      return unless framework
      framework.observe(:observations, [category, key, observation, at], [], false)
    end
  end
end
