# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/graft'

module Sqreen
  module Graft
    class Callback
      attr_reader :name, :rank, :mandatory, :flow, :ignore

      def initialize(name = nil, opts = {}, &block)
        @name = name
        @rank = opts[:rank] || 0
        @mandatory = opts[:mandatory] || false
        @flow = opts[:flow] || false
        @ignore = opts[:ignore] || false
        @block = block
        @disabled = false
      end

      def call(*args, &block)
        # Sqreen::Graft.logger.debug { "[#{Process.pid}] Callback #{@name} disabled:#{disabled?}" } if Sqreen::Graft.logger.debug?
        return if @disabled
        @block.call(*args, &block)
      end

      def disable
        @disabled = true
      end

      def enable
        @disabled = false
      end

      def disabled?
        @disabled
      end
    end
  end
end
