# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

# TODO: => Sqreen::JS:ExecJS

require 'execjs'
require 'weakref'
require 'sqreen/js/executable_js'
require 'sqreen/js/js_service_adapter'
require 'sqreen/js/exec_js_runnable'
require 'sqreen/js/thread_local_exec_js_runnable'

module Sqreen
  module Js
    class ExecjsAdapter < JsServiceAdapter
      def preprocess(rule_name, code)
        if thread_safe?
          ExecJsRunnable.new(ExecJS.compile(code))
        else
          ThreadLocalExecJsRunnable.new(code)
        end
      end

      def variant_name
        ExecJS.runtime.name + ' (ExecJS)'
      end

      private

      def thread_safe?
        ExecJS.runtime.name != 'therubyrhino (Rhino)'
      end
    end
  end
end
