# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

# TODO: => Sqreen::JS:MiniRacer

require 'digest'
require 'json'
require 'sqreen/js/executable_js'
require 'sqreen/js/js_service_adapter'
require 'sqreen/js/context_pool'
require 'sqreen/js/mini_racer_executable_js'

module Sqreen
  module Js
    DEFAULT_GC_THRESHOLD = 15000000  # 15 MB

    class MiniRacerAdapter < JsServiceAdapter
      def initialize(vendored = false)
        @vendored = vendored
        @pool = ContextPool.new
        self.class.static_init
      end

      def preprocess(rule_name, code)
        Sqreen.log.debug("js:#{self.class.name} variant:#{variant_name} preprocess:#{rule_name}")
        MiniRacerExecutableJs.new(@pool, code, @vendored)
      end

      def variant_name
        @vendored ? 'sq_mini_racer' : 'mini_racer'
      end

      def self.static_init
        return if @done_static_init
        Sqreen::MiniRacer::Platform.set_flags! :noconcurrent_recompilation
        @done_static_init = true
      end
    end
  end
end
