# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'logger'
require 'sqreen/log'

module Sqreen; end
module Sqreen::Log; end

module Sqreen::Log::Loggable
  def self.included(klass)
    klass.extend(ClassMethods)
  end

  module ClassMethods
    def logger
      # TODO: use progname for qualified log messages
      # TODO: qualified logger proxies for selectable levels per component
      # @logger ||= ::Logger.new(STDOUT, progname: name, level: Logger::DEBUG)
      Sqreen.log
    end
  end

  def logger
    @logger || singleton_class.logger
  end
end
