# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'singleton'

module Sqreen
  class NullLogger
    include Singleton

    def debug?
      false
    end

    def info?
      false
    end

    def warn?
      false
    end

    def error?
      false
    end

    def fatal?
      false
    end

    def debug(_msg = nil); end

    def info(_msg = nil); end

    def warn(_msg = nil); end

    def error(_msg = nil); end

    def fatal(_msg = nil); end

    def unknown(_msg = nil); end

    def add(_severity, _msg = nil); end

    def formatter=(_); end
  end
end
