# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/rules/attrs'
require 'sqreen/rules/rule_cb'
require 'sqreen/safe_json'

module Sqreen
  module Rules
    class AuthTrackCB < RuleCB
      def initialize(*args)
        super(*args)
        @overtimeable = false
      end

      def pre(_instance, args, _budget)
        success, authentication_keys = args
        ip = framework.client_ip
        category = success ? 'sdk-login-success' : 'sdk-login-fail'

        if authentication_keys.empty?
          Sqreen.log.debug { "#{category} from #{ip} but keys empty" }
          return
        end

        payload = { keys: authentication_keys.to_a, ip: ip }

        record_observation(category, JSON.dump(payload), 1)
        advise_action(nil)
      end
    end
  end
end
