# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'openssl'

## Rules signature
module Sqreen
  # Perform an EC + digest verification of a message.
  class SignatureVerifier
    def initialize(key, digest)
      @pub_key              = OpenSSL::PKey.read(key)
      @digest               = digest
    end

    def verify(sig, val)
      hashed_val = @digest.digest(val)
      @pub_key.dsa_verify_asn1(hashed_val, sig)
    end
  end
end
