# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/util'

class Sqreen::Util::CappedString < String
  attr_reader :size_cap

  def initialize(*args, &block)
    opts = args.last.is_a?(Hash) ? args.pop : {}
    size_cap = opts[:size_cap] || 4096
    @size_cap = size_cap
    super(*args, &block)
  end

  def <<(value)
    return self unless size < size_cap

    value = value[0, size_cap - size] if size + value.size > size_cap

    super(value)
  end
  alias_method :concat, :<<
end
