# typed: ignore

# Copyright (c) 2015 Sqreen. All Rights Reserved.
# Please refer to our terms for more information: https://www.sqreen.com/terms.html

require 'sqreen/runtime_infos'
require 'sqreen/events/remote_exception'
require 'sqreen/payload_creator/header_section'

module Sqreen
  class PayloadCreator
    # object that default to call on framework header
    class HeaderSection
      def initialize(framework)
        @framework = framework
      end

      def [](value)
        if %w[rack_client_ip rails_client_ip ip_headers].include?(value)
          return @framework.send(value)
        end
        @framework.header(value)
      end

      def ip_headers
        @framework.ip_headers
      end
    end
  end
end
